/*
Scrivere un programma per la gestione dei dipendenti e delle loro attivit.
I dipendenti sono caratterizzati da: nominativo, matricola dipendente, anni anzianit e tipo di qualifica (0..3).
Le attivit sono caratterizzate da: matricola dipendente, data, codice attivit (0..7). 
I dipendenti sono inseriti in un vettore di 4 liste,  una per ogni tipo di qualifica. 
Le attivit sono inserite in una tabella allocata dinamicamente avente 8 righe, una  per ogni codice attivit.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento  ordinato rispetto alla matricola nel vettore di liste di un nuovo dipendente; 
2.	Visualizzazione dei dipendenti con una certa anzianit (chiedere tipo di qualifica e gli anni di anzianit);
3.	Inserimento di una nuova attivit;
4.	Visualizzazione delle attivit relative a una certa data (chiedere la data);
5.	Salvataggio su file delle attivit;
6.	Lettura da file e inserimento in tabella delle attivit precedentemente salvate.

Liberare la memoria allocata dinamicamente.

*/

#include <stdio.h>
#include <stdlib.h>
#include<string.h>


typedef struct{
               char nominativo[20];
               int matricola,anni,tipoqualifica;
              }dipendente;
              
struct atomo{
             dipendente dato;
             struct atomo *next;
            };
            
typedef struct{
               int matricola,codiceattivita;
               char data[10];
              }attivita;
              
void menu();
void leggi_attivita(attivita *p);
void ins_attivita(attivita *TP[8],int *N, attivita p);
void vis_attivita(attivita *TP[8],int *N);
void salva(attivita *TP[8],int *N);
void carica(attivita *TP[8],int *N);
void leggi_dipendente(dipendente *s);
void ins_dipendente(struct atomo **TL, dipendente s);
void vis_dipendente(struct atomo *TL[4]);



main(){
       struct atomo *LC[4],*a;
       attivita *TP[8];
       attivita p;
       dipendente s;
       int N[8],opz,i;
       
       /*inizializzazione tabella*/
       for(i=0;i<8;i++)
       {
                        TP[i]=NULL;
                        N[i]=0;
       }
       /*inizializzazione lista */
       for(i=0;i<4;i++)
          LC[i]=NULL;
          
       do{menu();
          scanf("%d",&opz);
          switch(opz){
                      case 1: leggi_dipendente(&s);
                              ins_dipendente(&LC[s.tipoqualifica],s);
                              break;
                      case 2: vis_dipendente(LC);
                              break;
                      case 3: leggi_attivita(&p);
                              ins_attivita(TP,N,p);
                              break;
                      case 4: vis_attivita(TP,N);
                              break;        
                      case 5: salva(TP,N);
                              break;
                      case 6: carica(TP,N);
                              break;
                      default:;
                     }
          }while(opz!=0);
           
           /* liberazione della memoria */
           for(i=0;i<4;i++)
             while(LC[i]!=NULL)
             {
               a=LC[i];
               LC[i]=a->next;
               free (a);
             }    
           
           for(i=0;i<8;i++)
              free(TP[i]);
      }
      
void menu()
{ 
            	printf("\nPROGRAMMA PER LA GESTIONE DEI DIPENDENTI E DELLE LORO ATTIVITA\n");
                printf("\nScegli fra:\n");
                printf(" 1) Inserimento ordinato di nuovo dipendete\n");
                printf(" 2) Visualizza dipendeti per anzianita'\n");
                printf(" 3) Inserimento  nuova attivita\n");
                printf(" 4) Visualizza attivita per data\n");
                printf(" 5) Salvataggio su file delle attivita\n");
                printf(" 6) Lettura da file delle attivita\n");
                printf(" 0) Fine\n\n");
}     
 
 
 

/*funzioni lista*/
void leggi_dipendente(dipendente *s)  
             {    
     printf("Inserisci nominativo: ");
     scanf("%s", s->nominativo);
     printf("Inserisci la matricola dipendete : ");
     scanf("%d",&s->matricola);
     printf("Inserisci anni anzianit: ");
     scanf("%d",&s->anni);
     printf("Inserisci il tipo di qualifica(0..3): ");
     scanf("%d",&s->tipoqualifica);
}    

void ins_dipendente(struct atomo **TL, dipendente s)
{
      struct atomo *aux,*l1,*l2;
             
             aux=malloc(sizeof(struct atomo));
             if(aux==NULL) return;
             
             aux->dato=s;
             
             if(*TL==NULL||s.matricola<(*TL)->dato.matricola)
                /* inserimento in testa*/
                  {
                     aux->next=*TL;
                     *TL=aux;
                     return;
                  }
             /* inserimento in posizione successiva*/     
             l2=*TL;
             l1=l2->next;
             
             while(l1!=NULL)
                 if(s.matricola<l1->dato.matricola)
                     break;
                 else{ l2=l1;
                       l1=l1->next;
                     }
               
             
             l2->next=aux;
             aux->next=l1;
}                   
                         
void vis_dipendente(struct atomo *TL[4])
{  
        	int tipoqualifica,anni;
        	struct atomo *aux;
        
        	printf("Inserisci il tipo di qualifica(0..3)\n");
        	scanf("%d",&tipoqualifica);
        	
        	printf("Inserisci anni di anzianita'\n");
        	scanf("%d",&anni);
        
        	aux=TL[tipoqualifica];
        	while(aux!=NULL)
        	 { if(aux->dato.anni==anni)
        		 {	printf("Nominativo %s\n",aux->dato.nominativo);
        			printf("Matricola: %d\n",aux->dato.matricola);
        			
        		 }
        	   aux=aux->next;
             }	
}
  
            
void leggi_attivita(attivita *p)
{    
     printf("Inserisci la Matricola dipendete: ");
     scanf("%d",&p->matricola);
     printf("Inserisci la data dell'attivit: ");
     scanf("%s",p->data);
     printf("Inserisci il codice dell'attivita(0..3): ");
     scanf("%d",&p->codiceattivita);
}



void ins_attivita(attivita *TP[8],int *N, attivita p)
{
        int i,k,codiceattivita;
        attivita *R;
               
        codiceattivita=p.codiceattivita;
        
        R=realloc(TP[codiceattivita],sizeof(attivita)*(N[codiceattivita]+1));
        if(R==NULL) return;
        
        /* inserimento in ultima posizione*/
        TP[codiceattivita]=R;
        TP[codiceattivita][N[codiceattivita]]=p;
        N[codiceattivita]++;
}
                
        
        

 void vis_attivita(attivita *TP[8],int *N)
{
     int i,j;
     char data[10];
     
     printf("Inserisci la data:\n ");
     scanf("%s",data);
    
     for(i=0;i<8;i++)
       for(j=0;j<N[i];j++)
          if(strcmp(TP[i][j].data,data)==0)  /* attivita della data scelta */
             {   
               printf("matricola:%d\n",TP[i][j].matricola);
               printf("Codice attivita:%d\n",TP[i][j].codiceattivita);  
             }
}
        


         
void salva(attivita *TP[8],int *N)
    {
    	FILE *pf;
    	int i;
    	pf=fopen("attivita.at","wb");
    	if(pf!=NULL)
    		{ for(i=0;i<8;i++)
    	         fwrite(TP[i],sizeof(attivita),N[i],pf);
    		  fclose(pf);
    	}
    	else printf("Errore in scrittura\n");
    }

void carica(attivita *TP[8],int *N)
{      
       FILE *pf;
       int data ;
       attivita p,*R;

       pf=fopen("attivita.at","rb");
       if(pf)
         {
            while(fread(&p,sizeof(attivita),1,pf))
               ins_attivita(TP,N,p);
           fclose(pf);
         }
       else printf("Errore in lettura\n");
}    
                                   

                                  


                    
                           
                           
                           
                           
                           
                           
                           
                           
    
            
